
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sched.h>
#include <signal.h>
#include "event.h"
#include "comm/comm.h"

#ifndef MEDUSA_INITNAME
#define MEDUSA_INITNAME	"/sbin/init"
#endif

int procmem_init( void );
int vs_init( int max_vs );
int language_init( char *filename );
int execute_init( void );
int cmds_init( void );

int language_do( void );

extern struct event_handler_s *function_init;

#ifdef RBAC
char *rbac_conf="/etc/rbac.conf";
int rbac_init( void );
int rbac_load( char *userfile, char *conffile );
#endif

static int test=0;

int init_after_comm( char *filename )
{
	if( vs_init(comm_vs_size())<0 )
		return(-1);
	if( cmds_init()<0 )
		return(-1);
	if( procmem_init()<0 )
		return(-1);
#ifdef RBAC
	if( rbac_init()<0 )
//		return(-1);
	;
#endif
	if( execute_init()<0 )
		return(-1);
	if( language_init(filename)<0 )
		return(-1);
	if( language_do()<0 )
		return(-1);
//printf("ZZZ: All initialized\n");
#ifdef RBAC
	if( rbac_load("/etc/passwd",rbac_conf)<0 )
		return(-1);
#endif
	if( !test && function_init!=NULL )
	{ struct event_context_s c;
		get_empty_context(&c);
		function_init->handler(function_init,&c);
	}
	return(0);
}

int usage( char *me )
{
	fprintf(stderr,"usage: %s [-t] [<config. file>] [-d <device>]"
#ifdef RBAC
		" [-r <rbac config. file>]"
#endif
		"\n",me);
	return(0);
}

static int run_init( int argc, char *argv[] )
{ int i;
//  int status;

	switch ((i = fork()))
	{
		case -1:
			return(0);
		case 0:
			return(1);
		default:
			pause();
//			waitpid(i, &status, 0);
//			if (!WIFEXITED(status))
//				exit(-1);
			argv[0] = MEDUSA_INITNAME;
			execvp(argv[0], argv);
			exit(-1);
	}
	return(0);
}

int main( int argc, char *argv[] )
{ char *conf_name="/etc/medusa.conf";
  char *devname="/dev/medusa";
  struct sched_param schedpar;
  int a;
  int kill_init=0;
  int r;

	if( getpid() <= 1 )
		kill_init=run_init(argc,argv);

	for(a=1;a<argc;a++)
	{
		if( argv[a][0]=='-' )
		{	if( argv[a][1]=='t' )
				test=1;
			else if( argv[a][1]=='d' && a+1<argc )
			{	a++;
				devname=argv[a];
			}
#ifdef RBAC
			else if( argv[a][1]=='r' && a+1<argc )
			{	a++;
				rbac_conf=argv[a];
			}
#endif
			else
				return(usage(argv[0]));
		}
		else
		{	conf_name=argv[a];
		}
	}

	if( comm_open(devname)<0 )
		return(-1);
	while( (r=comm_do((int(*)(void *))init_after_comm,conf_name))==0 );
	if( r<0 )
		return(-1);
	if( test )
		return(0);
printf("ZZZ: bude dobre\n");
//	setsid();
//	schedpar.sched_priority = sched_get_priority_max(SCHED_FIFO);
//	sched_setscheduler(0, SCHED_FIFO, &schedpar);
	if( kill_init )
		kill(1,SIGHUP);
	while( comm_do(NULL,NULL)>=0 );
	return(-1);
}

