
#include "execute.h"
#include "../constable.h"
#include "../object.h"
#include <sys/param.h>

struct object_s *r2o( struct register_s *r )
{ static struct object_s o={NULL,{0,0,0,""},0,NULL,NULL};
	if( r->data==r->buf )
		o.data= r->data - r->attr->offset;
	else	o.data= r->data;
	o.flags=r->flags;
	return(&o);
}

int r_int( struct register_s *r )
{ int d=0;
	switch( r->attr->type & 0x0f )
	{	case MED_TYPE_SIGNED:
		case MED_TYPE_UNSIGNED:
			object_get_val(r2o(r),r->attr,&d,sizeof(d));
			return(d);
	}
//!!??!!	runtime("r_int from non integer");
	return(0);
}

#define LEN_ALIGN(x)	(((x)+3)&(~0x03))
#define LEN_MAX		(MAX_REG_SIZE&(~0x03))

void r_imm( struct register_s *r )
{ int n;
	if( r->data==r->buf )
		return;
	n= LEN_ALIGN(r->attr->length);
	if( n>MAX_REG_SIZE )
	{	runtime("Variable too long");
		n=LEN_MAX;
	}
	if( r->attr->type==MED_TYPE_END && n>0 )
	{	memcpy(r->buf,r->data + r->attr->offset,n);
	}
	else
	{	object_get_val(r2o(r),r->attr,r->buf,n);
		r->flags&=~OBJECT_FLAG_CHENDIAN;
	}
	r->data=r->buf;
	r->flags&=~OBJECT_FLAG_LOCAL;
	r->object=NULL;
}

int strnlen( char *s, int n )
{ int i=0;
	while( i<n && s[i]!=0 )
		i++;
	return(i);
}

void r_sto( struct register_s *v, struct register_s *d )
{ u_int8_t type,typed;
  struct medusa_attribute_s tmpa;
	if( v->data==v->buf )
	{	runtime("Invalid lvalue");
//if( (d->attr->type & 0x0f)==MED_TYPE_STRING )
//printf("ZZZ: r_sto: str=\"%s\"\n",d->data);
		return;
	}
	if( !(v->flags&OBJECT_FLAG_LOCAL) && v->attr->type & MED_TYPE_READ_ONLY )
	{	runtime("Changing read-only varible");
		return;
	}
	type=v->attr->type&0x0f;
	typed=d->attr->type&0x0f;
	if( type==MED_TYPE_UNSIGNED && typed==MED_TYPE_SIGNED )
		type=MED_TYPE_UNSIGNED;
	else if( type==MED_TYPE_SIGNED && typed==MED_TYPE_UNSIGNED )
		type=MED_TYPE_UNSIGNED;
	else if( type==MED_TYPE_BITMAP && typed==MED_TYPE_SIGNED )
		type=MED_TYPE_SIGNED;
	else if( type==MED_TYPE_BITMAP && typed==MED_TYPE_UNSIGNED )
		type=MED_TYPE_UNSIGNED;
	else if( type != typed )
	{	runtime("Illegal type conversion [%1x->%1x]",typed,type);
		return;
	}
	if( type==MED_TYPE_END )
	{	if( v->attr->length==d->attr->length && v->class==d->class )
			memcpy(v->data+v->attr->offset,d->data,v->attr->length);
			/* FIXME: nie je skonverteny byte order */
		else	runtime("Class of object don't match");
		return;
	}
	r_imm(d);	/* len kvoli konverteniu byte orderu d-cka */
	memcpy(&tmpa,v->attr,sizeof(tmpa));
	tmpa.type=type;
	object_set_val(r2o(v),&tmpa,d->data,d->attr->length);
}

void r_resize( struct register_s *v, int size )
{ int nv;
	if( v->data!=v->buf )
		r_imm(v);
	nv=v->attr->length;
	switch( v->attr->type&0x0f )
	{	case MED_TYPE_END:
			runtime("Object can't be resized");
			return;
		case MED_TYPE_UNSIGNED:
		case MED_TYPE_SIGNED:
			nv=LEN_ALIGN(nv);
	}
	if( nv >= size )
		return;
	object_resize_data(v->data,v->attr,size);
}

