
#ifndef _LANGUAGE_H
#define _LANGUAGE_H

#include <mmm/compiler.h>
#include <mmm/lex.h>

enum {
	Tpp = T|0x100,		/* ++ */
	Tmm,			/* -- */
	TshiftL,		/* << */
	TshiftR,		/* >> */
	Tle,			/* <= */
	Tge,			/* >= */
	Teq,			/* == */
	Tne,			/* != */
	Tand,			/* && */
	Txor,			/* ^^ */
	Tor,			/* || */

	Tif,			/* if */
	Telse,			/* else */
	Twhile,			/* while */
	Tdo,			/* do */
	Tfor,			/* for */
	Tbreak,			/* break */
	Tcontinue,		/* continue */
	Tswitch,		/* switch */
	Tcase,			/* case */
	Tdefault,		/* default */
	Treturn,		/* return */
	Tgoto,			/* goto */

	Tfunction,		/* function */
	Tcallfunc,		/* callfunc */
	Tforce,			/* force */
	Tfetch,			/* fetch */
	Tupdate,		/* update */
	Ttransparent,		/* transparent */
	Tlocal,			/* local */

	Tbuildin,		/* buildin */

	/* conf. language */
	Tprimary,		/* primary */
	Tspace,			/* space */
	Trecursive,		/* recursive */
	Taccess,		/* <access type> */
//	Tobject,		/* object */
	Tby,			/* by */
	Tof,			/* of */

	T_id,			/* <identifikator> */
	T_str,
	T_path,
	T_num,
	T_arg,
};


enum {
	oNOP = O|0x100,
	oLD0,
	oLD1,
	oLDI,
	oLTI,
	oLTS,
	oLTP,
	oSTO,
	oSWP,
	oDEL,
	oDEn,
	oIMM,
	oLDC,
	oLDV,
	oLDS,
	oNEW,
	oTNW,
	oARG,
	oDUP,
	oADD,	/* poradie oADD - oXOR sa nesmie zmenit! */
	oSUB,
	oMUL,
	oDIV,
	oMOD,
	oSHL,
	oSHR,
	oLT,
	oGT,
	oLE,
	oGE,
	oEQ,
	oNE,
	oOR,
	oAND,
	oXOR,
	oNOT,
	oNEG,

	oJR,
	oJIZ,
	oJNZ,
	oJSR,
	oRET,

	oBIN,	/* buildin */
	oFRC,	/* force */
	oFET,	/* fetch */
	oUPD,	/* update */

	oILL=O|0x0fff	/* illegal */
};

#define	START	N|0x0a00
#define	SRET0	N|0x0aff
#define	CMD	N|0x0c00
#define	CMDS	N|0x0c30
#define	S_val	N|0x0d00
#define	S_exp	N|0x0e00
#define	S_exp2	N|0x0e01
/* N|0x0e00-0x0e40 - reserved for expressions */
#define	Pid2class	PO|0x0a20
#define	Pforce		PO|0x0a40

extern struct compile_tab_s conf_lang[];
extern struct compile_tab_s language[];
extern struct compile_tab_s value[];
extern struct compile_tab_s expression[];

extern lextab_t operators[];
extern lextab_t keywords[];
extern lextab_t *keywords2;
extern lexstattab_t lex_tab[];

int lex_updatekeyword( char *keyword, sym_t sym, unsigned long data );
int lex_addkeyword( char *keyword, sym_t sym, unsigned long data );

extern struct compiler_err_class s_error;

#endif /* _LANGUAGE_H */
