#include "constable.h"
#include "object.h"

static struct class_s *classes=NULL;

struct class_s *get_class_by_name( char *name )
{ struct class_s *c;
	for(c=classes;c!=NULL;c=c->next)
		if( !strncmp(c->m.name,name,MEDUSA_CLASSNAME_MAX) )
			return(c);
	return(NULL);
}

struct class_s *get_class_by_id( u_int32_t id )
{ struct class_s *c;
	for(c=classes;c!=NULL;c=c->next)
		if( c->m.classid==id )
			return(c);
	return(NULL);
}

struct class_s *add_class( struct medusa_class_s *mc, struct medusa_attribute_s *a )
{ struct class_s *c,**p;
  int i,l;
  struct medusa_attribute_s *ci;
	if( a==NULL )	a=(struct medusa_attribute_s *)(mc+1);
	for(i=0;a[i].type!=MED_TYPE_END;i++);
	i++;
	l=sizeof(struct class_s)+i*sizeof(struct medusa_attribute_s);
	if( (c=malloc(l))==NULL )
		return(NULL);
	c->m=*mc;
	memcpy(c->attr,a,i*sizeof(struct medusa_attribute_s));

	if( (ci=get_attribute(c,"o_cinfo"))!=NULL )
	{	c->cinfo_offset=ci->offset;
		c->cinfo_size=(ci->length)/sizeof(u_int32_t);
	}
	else	c->cinfo_offset=c->cinfo_size=0;
	c->cinfo_mask=0;
	c->set=NULL;
	if( (ci=get_attribute(c,"name"))!=NULL )
	{	c->name_offset=ci->offset;
		c->name_size=ci->length;
	}
	else	c->name_offset=c->name_size=0;
	if( (ci=get_attribute(c,"vs"))!=NULL )
	{	c->vs_offset=ci->offset;
		c->vs_size=(ci->length)/sizeof(u_int32_t);
	}
	else	c->vs_offset=c->vs_size=0;
	if( (ci=get_attribute(c,"med_oact"))!=NULL )
	{	c->event_offset=ci->offset;
		c->event_size=ci->length;
	}
	else	c->event_offset=c->event_size=0;
	/* subject */
	c->subject.getvs=NULL;
	c->subject.vs_offset[AT_MEMBER]=c->vs_offset;
	if( (ci=get_attribute(c,"vsr"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_RECEIVE]=ci->offset;
	else	c->subject.vs_offset[AT_RECEIVE]= -1;
	if( (ci=get_attribute(c,"vsw"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_SEND]=ci->offset;
	else	c->subject.vs_offset[AT_SEND]= -1;
	if( (ci=get_attribute(c,"vss"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_SEE]=ci->offset;
	else	c->subject.vs_offset[AT_SEE]= -1;
	if( (ci=get_attribute(c,"vsc"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_CREATE]=ci->offset;
	else	c->subject.vs_offset[AT_CREATE]= -1;
	if( (ci=get_attribute(c,"vsd"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_ERASE]=ci->offset;
	else	c->subject.vs_offset[AT_ERASE]= -1;
	if( (ci=get_attribute(c,"vse"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_ENTER]=ci->offset;
	else	c->subject.vs_offset[AT_ENTER]= -1;
	if( (ci=get_attribute(c,"vsx"))!=NULL && c->vs_size==(ci->length)/sizeof(u_int32_t) )
		c->subject.vs_offset[AT_CONTROL]=ci->offset;
	else	c->subject.vs_offset[AT_CONTROL]= -1;

	if( (ci=get_attribute(c,"med_sact"))!=NULL )
	{	c->subject.event_offset=ci->offset;
		c->subject.event_size=ci->length;
	}
	else	c->subject.event_offset=c->subject.event_size=0;

	if( (ci=get_attribute(c,"s_cinfo"))!=NULL )
	{	c->subject.cinfo_offset=ci->offset;
		c->subject.cinfo_size=(ci->length)/sizeof(u_int32_t);
	}
	else	c->subject.cinfo_offset=c->subject.cinfo_size=0;
	c->subject.cinfo_mask=0;
	
	for(p=&classes;(*p)!=NULL;p=&((*p)->next))
		if( !strncmp((*p)->m.name,c->m.name,MEDUSA_CLASSNAME_MAX) )
		{	free(c);
			return(NULL);
		}
	c->next=*p;
	*p=c;
	return(c);
}

/* vrati offset (u_int16_t), alebo -1 ak chyba */
int class_alloc_object_cinfo( struct class_s *c )
{ int i;
	for(i=0;i<c->cinfo_size && i<sizeof(c->cinfo_mask)*8;i++)
	{	if( !(c->cinfo_mask & (1<<i)) )
		{	c->cinfo_mask|= 1<<i;
			return(c->cinfo_offset+i*sizeof(u_int32_t));
		}
	}
	return(-1);
}

/* vrati offset (u_int16_t), alebo -1 ak chyba */
int class_alloc_subject_cinfo( struct class_s *c )
{ int i;
	for(i=0;i<c->subject.cinfo_size && i<sizeof(c->subject.cinfo_mask)*8;i++)
	{	if( !(c->subject.cinfo_mask & (1<<i)) )
		{	c->subject.cinfo_mask|= 1<<i;
			return(c->subject.cinfo_offset+i*sizeof(u_int32_t));
		}
	}
	return(-1);
}

int class_add_sethandler( struct class_s *c, int(*handler)(struct object_s *, u_int32_t *,void *), u_int16_t cinfo_offset, void *user )
{ struct class_set_s *s,**p;
	if( (s=malloc(sizeof(struct class_set_s)))==NULL )
		return(-1);
	s->cinfo_offset=cinfo_offset;
	s->user=user;
	s->handler=handler;
	for(p=&(c->set);*p!=NULL;p=&((*p)->next));
	s->next=NULL;
	*p=s;
	return(0);
}

int object_is_invalid( struct object_s *o )
{
	if( o->class->cinfo_size>0 && ((u_int32_t*)(o->data+o->class->cinfo_offset))[0]!=0 )
		return(0);
	if( o->class->subject.cinfo_size>0 && ((u_int32_t*)(o->data+o->class->subject.cinfo_offset))[0]!=0 )
		return(0);
	return(1);
}

int object_do_sethandler( struct object_s *o )
{ struct class_set_s *s;
	/* ZZZ Ten test je nic moc, ale co uz... */
//printf("ZZZ: object_do_sethandler 1\n");
//{int i;
//printf("[");
//for(i=0;i<o->class->cinfo_size;i++)
//printf("0x%08x ",((u_int32_t*)(o->data+o->class->cinfo_offset))[i]);
//printf("]\n(");
//for(i=0;i<o->class->subject.cinfo_size;i++)
//printf("0x%08x ",((u_int32_t*)(o->data+o->class->subject.cinfo_offset))[i]);
//printf(")\n");
//}
	object_clear_all_vs(o);
//printf("ZZZ: object_do_sethandler 4\n");
	object_clear_event(o);
//printf("ZZZ: object_do_sethandler 5\n");
	for(s=o->class->set;s!=NULL;s=s->next)
//{
//printf("ZZZ: object_do_sethandler riesim %p,%d\n",s->handler,s->cinfo_offset);
		s->handler(o,(u_int32_t*)(o->data + s->cinfo_offset),s->user);
//}
//printf("ZZZ: object_do_sethandler 6\n");
//printf("ZZZ object_do_sethandler 0x%08x 0x%08x\n", o->class->subject.event_size>0 ? *((u_int32_t*)(o->data+o->class->subject.event_offset)) : 0  ,*((u_int32_t*)(o->data+o->class->event_offset)) );
	return(0);
}

struct medusa_attribute_s *get_attribute( struct class_s *c, char *name )
{ struct medusa_attribute_s *a;
	if( c==NULL )	return(NULL);
	for(a=c->attr;a->type!=MED_TYPE_END;a++)
		if( !strncmp(a->name,name,MEDUSA_ATTRNAME_MAX) )
			return(a);
	return(NULL);
}

int object_is_same( struct object_s *a, struct object_s *b )
{ struct class_s *c;
  struct medusa_attribute_s *t;
	if( (c=a->class) != b->class )
		return(0);
	for(t=c->attr;t->type!=MED_TYPE_END;t++)
//{if( (t->type & MED_TYPE_PRIMARY_KEY) )
//printf("PK \"%s\" %d ? %d\n",t->name,
//*((int*)(a->data+t->offset)),
//*((int*)(b->data+t->offset)) );
		if( (t->type & MED_TYPE_PRIMARY_KEY)
		     && memcmp(a->data+t->offset,b->data+t->offset,t->length) )
			return(0);
//}
	return(1);
}


int object_clear_event( struct object_s *o )
{
	if( o->class->event_size>0 )
		memset(o->data + o->class->event_offset,0,o->class->event_size);
	/* subject */
	if( o->class->subject.event_size>0 )
		memset(o->data + o->class->subject.event_offset,0,o->class->subject.event_size);
	return(0);
}

int object_add_event( struct object_s *o, event_mask_t *e )
{ int i,n;
  char *f,*t;
	/* object */
	if( (n=o->class->event_size)<=0 )
		return(-1);
	if( n>sizeof(e->bitmap) )
		n=sizeof(e->bitmap);
	f=e[1].bitmap;
	t=o->data + o->class->event_offset;
	for(i=0;i<n;i++)
		t[i] |= f[i];
	/* subject */
	if( (n=o->class->subject.event_size)<=0 )
		return(0);
	if( n>sizeof(e->bitmap) )
		n=sizeof(e->bitmap);
	f=e[0].bitmap;
	t=o->data + o->class->subject.event_offset;
	for(i=0;i<n;i++)
		t[i] |= f[i];
	return(0);
}

int class_add_getvs( struct class_s *c, int(*get)(vs_t *vs,int n,struct object_s *o,u_int32_t *cinfo), u_int16_t cinfo_offset )
{ struct subject_get_s *p;
	if( (p=malloc(sizeof(struct subject_get_s)))==NULL )
		return(-1);
	p->cinfo_offset=cinfo_offset;
	p->get=get;
	p->next=c->subject.getvs;
	c->subject.getvs=p;
	return(0);
}

int object_get_vs( vs_t *vs, int n, struct object_s *o )
{ struct subject_get_s *p;
	if( n<0 || n>=NR_ACCESS_TYPES )
	{	vs_clear(vs);
		return(-1);
	}
	if( o->class->subject.vs_offset[n]>=0 && o->class->vs_size>0 )
	{	vs_set((vs_t*)(o->data + o->class->subject.vs_offset[n]),vs);
		return(0);
	}
	vs_clear(vs);
	for(p=o->class->subject.getvs;p!=NULL;p=p->next)
		p->get(vs,n,o,(u_int32_t*)(o->data + p->cinfo_offset));
	return(0);
}

int object_clear_all_vs( struct object_s *o )
{ int n;
	for(n=0;n<NR_ACCESS_TYPES;n++)
	{	if( o->class->subject.vs_offset[n]>=0 && o->class->vs_size>0 )
		{	vs_clear((vs_t*)(o->data + o->class->subject.vs_offset[n]));
		}
	}
	return(0);
}

int object_add_vs( struct object_s *o, int n, vs_t *vs )
{ 
	if( n<0 || n>=NR_ACCESS_TYPES )
		return(-1);
	if( o->class->subject.vs_offset[n]>=0 && o->class->vs_size>0 )
	{	vs_add(vs,(vs_t*)(o->data + o->class->subject.vs_offset[n]));
		return(0);
	}
	return(-1);
}

void attr_print( struct medusa_attribute_s *a )
{ int i;
  static char *t[]={"END","unsigned","signed","string","bitmap"};
	for(i=0;a[i].type!=MED_TYPE_END;i++)
	{	printf("\t%s%s%s\t%s\t(%d: %d)\n",(a[i].type&0x80?"readonly ":""),(a[i].type&0x40?"primary ":""),t[a[i].type & 0x0f] ,a[i].name,a[i].offset,a[i].length);
	}
}

void class_print( struct class_s *c )
{
	printf("class %s {\n",c->m.name);
	attr_print(&(c->attr[0]));
	printf("}\n");
}


