
#ifndef _OBJECT_H
#define _OBJECT_H

#include "types.h"
#include "medusa_object.h"
#include "vs.h"
#include "access_types.h"

struct object_s;

struct class_set_s {
	struct class_set_s	*next;
	u_int16_t		cinfo_offset;
	void			*user;
	int(*handler)(struct object_s *,u_int32_t *,void *);
};

struct subject_get_s {
	struct subject_get_s *next;
	u_int16_t		cinfo_offset;
	int(*get)(vs_t *vs,int n,struct object_s *o, u_int32_t *);
};


struct class_s {
	struct class_s			*next;
	u_int16_t			cinfo_offset;
	u_int16_t			cinfo_size;	/* v 32 bit slovach */
	u_int32_t			cinfo_mask;
	struct class_set_s		*set;
	u_int16_t			name_offset;
	u_int16_t			name_size;	/* v bajtoch */
	u_int16_t			vs_offset;
	u_int16_t			vs_size;	/* v 32 bit slovach */
	u_int16_t			event_offset;
	u_int16_t			event_size;	/* v bajtoch */
	struct {
			int		vs_offset[NR_ACCESS_TYPES];
			u_int16_t	event_offset;
			u_int16_t	event_size;	/* v bajtoch */
			u_int16_t	cinfo_offset;
			u_int16_t	cinfo_size;	/* v 32 bit slovach */
			u_int32_t	cinfo_mask;
			struct subject_get_s *getvs;
	}				subject;
	struct medusa_class_s		m;
	struct medusa_attribute_s	attr[0];
};

struct object_s {
	struct object_s *next;
	struct medusa_attribute_s attr;
	int	flags;
	struct class_s	*class;
	char	*data;
};
#define OBJECT_FLAG_LOCAL	0x01
#define OBJECT_FLAG_CHENDIAN	0x10	/* big<->little */
struct class_s *get_class_by_name( char *name );
struct class_s *get_class_by_id( u_int32_t id );
struct medusa_attribute_s *get_attribute( struct class_s *c, char *name );
struct class_s *add_class( struct medusa_class_s *mc, struct medusa_attribute_s *a );
int object_get_val( struct object_s *o, struct medusa_attribute_s *a, void *buf, int maxlen );
int object_set_val( struct object_s *o, struct medusa_attribute_s *a, void *buf, int maxlen );

/* vrati offset (u_int16_t), alebo -1 ak chyba */
int class_alloc_object_cinfo( struct class_s *c );
int class_alloc_subject_cinfo( struct class_s *c );

int class_add_sethandler( struct class_s *c, int(*handler)(struct object_s *, u_int32_t *,void *), u_int16_t cinfo_offset, void *user );
int class_add_getvs( struct class_s *c, int(*get)(vs_t *vs,int n,struct object_s *o,u_int32_t *cinfo), u_int16_t cinfo_offset );
int object_resize_data( void *buf, struct medusa_attribute_s *a, int newlen );

int object_is_same( struct object_s *a, struct object_s *b );

int object_clear_event( struct object_s *o );
int object_add_event( struct object_s *o, event_mask_t *e );

int object_get_vs( vs_t *vs, int n, struct object_s *o );
int object_clear_all_vs( struct object_s *o );
int object_add_vs( struct object_s *o, int n, vs_t *vs );

int object_is_invalid( struct object_s *o );
int object_do_sethandler( struct object_s *o );

void attr_print( struct medusa_attribute_s *a );
void class_print( struct class_s *c );

#endif

