
#include "procmem.h"
#include "constable.h"
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

#include <errno.h>

static int proc_pid_offset;
static int proc_pid_size;

int procmem_getpid( struct object_s *subject )
{ int pid= -1;
	switch( proc_pid_size )
	{	case 1:	pid=(int)(*((char*)(subject->data + proc_pid_offset)));
			break;
		case 2:	pid=(int)(*((u_int16_t*)(subject->data + proc_pid_offset)));
			break;
		case 4:	pid=(int)(*((u_int32_t*)(subject->data + proc_pid_offset)));
			break;
		case 8:	pid=(int)(*((u_int64_t*)(subject->data + proc_pid_offset)));
			break;
	}
	return(pid);
}

int procmem_readstr( struct object_s *subject, u_int32_t addr, char *buf, int maxlen )
{ int pid;
  int fd;
  char s[32];
	*buf=0;
	pid=procmem_getpid(subject);
	sprintf(s, "/proc/%d/mem", pid);
	if ((fd = open(s, O_RDONLY)) < 0)
		return(-1);
	lseek(fd, addr, SEEK_SET);

	while( maxlen>1 && read(fd,buf,1)==1 )
	{	if( *buf==0 )	break;
		buf++;
		maxlen--;
	}
	*buf=0;
	close(fd);
	return(0);
}

int procmem_writestr( struct object_s *subject, u_int32_t addr, char *buf )
{ int pid;
  int fd;
  char s[32];
	pid=procmem_getpid(subject);
	sprintf(s, "/proc/%d/mem", pid);
	if ((fd = open(s, O_RDWR)) < 0)
		return(-1);
	if( lseek(fd, addr, SEEK_SET)==(off_t)-1 )
	{	close(fd);
		return(-1);
	}

//printf("ZZZ: procmem_writestr 0x%x \"%s\"\n",addr,buf);
	{ int l=strlen(buf)+1;
		while(l>0)
		{	if( write(fd,buf,1)<0 )
			{	close(fd);
//perror("ZZZ error");
//printf("ZZZ errno=%d (0x%x\n",errno,errno);
				return(-1);
			}
			buf++;
			l--;
		}
	}

//	if( write(fd,buf,strlen(buf)+1)<0 )
//	{	close(fd);
//printf("ZZZ error\n");
//		return(-1);
//	}
	close(fd);
	return(0);
}

int procmem_init( void )
{ struct class_s *proc_class;
  struct medusa_attribute_s *a;
	if( (proc_class=get_class_by_name("process"))==NULL )
		if( (proc_class=get_class_by_name("proc"))==NULL )
			return(init_error("proc: Class 'proc' don't exist"));

	if( (a=get_attribute(proc_class,"pid"))==NULL )
		return(init_error("proc: Class 'proc' don't have attribute 'pid'"));
	proc_pid_offset=a->offset;
	proc_pid_size=a->length;
	return(0);
}

