
#ifndef _TREE_H
#define _TREE_H

#include "access_types.h"
#include "vs.h"
#include "event.h"

struct tree_s;
struct space_s;

struct tree_type_s {
	char	*name;
	int	size;		/* size of node */
	struct class_s	*obj_class;	/* pre eventy */
	int	cinfo_offset;
	void	*user;		/* pre sethandler */
	int	flags;		/* ach */
	int(*init)(struct tree_s*);
	struct tree_type_s *child_type;
};

struct tree_s {
	struct tree_s	*parent;
	struct tree_s	*child;		/* normalny potomkovia */
	struct tree_s	*reg;		/* potomkovia s regexpami */
	struct tree_s	*next;
	struct tree_s	*alt;		/* alternative */
	struct tree_type_s *type;
	char		*name;
	void		*extra;		/* precompiled regexp... */
	struct space_s	*primary_space;
	struct space_s	*recursive_primary_space;
	event_mask_t	event[2];
	event_mask_t	recursive_event[2];
	vs_t	vs[NR_ACCESS_TYPES][MAX_VS_BITS/32];
	vs_t	recursive_vs[NR_ACCESS_TYPES][MAX_VS_BITS/32];
};

typedef struct tree_type_s tree_type_t;

extern struct tree_s global_root;

struct tree_s *register_tree_type( tree_type_t *type );
struct tree_s *create_path( char *path );
struct tree_s *find_one( struct tree_s *base, char *name );
int tree_is_offspring( struct tree_s *offspring, struct tree_s *ancestor );

//int path_add_vs( char *path, int recursive, int which, const vs_t *vs );

char *tree_get_path( struct tree_s *t );

#endif

